;########################################################
;    for BBSOFITS by: Scot Kleinman, Nov. 96
;########################################################


PRO rslider_event, Event

COMMON IMDATA,im,imlast,header,oheader,imsize,contrast,ocontrast,dim,filename,$
       outname,helpfile,selection,oselection,traceplot,saveflag
 
COMMON RJUNK,rslider,abutton,cbutton

WIDGET_CONTROL,event.id,GET_UVALUE = rev

CASE rev OF

    'RSLIDE': begin
        WIDGET_CONTROL,rslider,GET_VALUE=nxn
     end

    'ABUTTON':begin
       ;do rebinning
       WIDGET_CONTROL, /HOURGLASS
       WIDGET_CONTROL,rslider,GET_VALUE=nxn
       imlast=im
       ocontrast=contrast
       oselection=selection
       dim=size(im)
       dxr=dim(1) mod nxn
       dyr=dim(2) mod nxn
       dim(1)=dim(1)-dxr
       dim(2)=dim(2)-dyr
       im=im(0:dim(1)-1,0:dim(2)-1)
       im=fix(round(nxn*nxn*rebin(float(im),dim(1)/nxn,dim(2)/nxn)))
       dim=size(im)
       ; Adjust the Header  if it's a FITS file
       if (strpos(header(0),'NO HEADER') ne 0) then begin ;Image is FITS
           oheader=header
           sxaddpar,header,'NAXIS1',dim(1)
           sxaddpar,header,'NAXIS2',dim(2)
           hl='IDL Rebinned '+strtrim(string(nxn),2)+'x'+strtrim(string(nxn),2)
           sxaddhist,hl,header
       endif
       ;# RESET SELECTION
       p1=[0.0,0.0+(imsize(1)-dim(2))]
       p2=[dim(1)-1,(dim(2)-1)+(imsize(1)-dim(2))]
       selection=fill_select(0.0,0.0,p1,p2,p1)
       erase
       contrast=contrast*nxn*nxn
       tv,bytscl(im,contrast(0),contrast(1)),0,imsize(1)-dim(2)
    END
 
    'CBUTTON':begin
        ;cancel - do nothing
        WIDGET_CONTROL,event.top,/destroy
        end

    'UBUTTON':begin
        ;undo
        im=imlast
        dim=size(im)
        contrast=ocontrast
        header=oheader
        selection=oselection
        tv,bytscl(im,contrast(0),contrast(1)),0,imsize(1)-dim(2)
        end
endcase

end

PRO bbsorebi,GROUP=Group
COMMON RJUNK, rslider,abutton,cbutton

rbase=WIDGET_BASE(TITLE='IDL Rebinning',XOFFSET=500, YOFFSET=400,/COLUMN)
minvalue=2
maxvalue=128
rslider=WIDGET_SLIDER(rbase,MINIMUM=minvalue,MAXIMUM=maxvalue,$
        TITLE='Select Rebin Size NxN',/FRAME,UVALUE='RSLIDE',XSIZE=300,$
        VALUE=2,DRAG=1)

rbase2 = WIDGET_BASE(rbase, $
      ROW=1, $
      MAP=1, $
      UVALUE='RBASE2')

cbutton = WIDGET_BUTTON(rbase2, $
      UVALUE='CBUTTON', $
      VALUE='OK')

abutton = WIDGET_BUTTON(rbase2, $
      UVALUE='ABUTTON', $
      VALUE='Apply')

ubutton = WIDGET_BUTTON(rbase2, $
      UVALUE='UBUTTON', $
      VALUE='Undo')

WIDGET_CONTROL,rbase,/REALIZE
XMANAGER,'rslider',rbase,GROUP_LEADER=Group

END
